using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Nicekit.Excel;


namespace ExcelDemoApplication
{
  public partial class Form1 : Form
  {
    private Excel excel = null;
    
    public Form1() {
      InitializeComponent();
      comboBoxColor1.Text = "Red";
      comboBoxColor2.Text = "White";
      comboBoxColor3.Text = "Blue";
    }

    private void buttonClose_Click(object sender, EventArgs e) {
      Close();
    }

    private void Form1_FormClosed(object sender, FormClosedEventArgs e) {
      if (excel != null) {
        excel.Dispose();
      }
    }

    private Excel getExcel() {
      //--- open excel
      if (excel == null) {
        excel = new Excel();
      }
      if (excel.Workbooks.Count() == 0) {
        excel.Workbooks.Add();
      }
      excel.ScreenUpdating = true;
      //---
      return excel;
    }

    private void buttonExcelShow_Click(object sender, EventArgs e) {
      getExcel().Visible = true;
    }

    private void buttonExcelHide_Click(object sender, EventArgs e) {
      getExcel().Visible = false;
    }

    private void buttonExcelMinimize_Click(object sender, EventArgs e) {
      getExcel().WindowState = Excel.xlWindowState.xlMinimized;
    }

    private void buttonExcelMaximize_Click(object sender, EventArgs e) {
      getExcel().WindowState = Excel.xlWindowState.xlMaximized;
    }

    private void buttonRun1_Click(object sender, EventArgs e) {
      using (Sheet sh = getExcel().Workbooks[1].ActiveSheet()) {
      // or using (Sheet sh = getExcel().Workbooks[1].Sheets[1]){
        using (Range r = sh.Ranges[textBoxCell1.Text]) {  //["A5"]; //["R2C3"];
          r.Value = textBoxText1.Text;  //"123";
          r.Font.Bold = checkBoxBold1.Checked;
          r.Font.Italic = checkBoxItalic1.Checked;
          r.Font.Underline = checkBoxUnderline1.Checked;
          r.Font.Size = (int)numericUpDownSize1.Value;
          r.Font.Name = "Times New Roman";//"Courier New";
          r.Font.Color = System.Drawing.Color.FromName(comboBoxColor1.Text); //System.Drawing.Color.Red
          r.HorizontalAlignment = Excel.xlHAlign.xlHAlignCenter;
          //System.Windows.Forms.MessageBox.Show(r.Font.Color.ToString());
        }
      }
    }

    private void buttonTest2_Click(object sender, EventArgs e) {
      using (Sheet sh = getExcel().Workbooks[1].ActiveSheet()) {
        // or using (Sheet sh = getExcel().Workbooks[1].Sheets[1]){
        using (Range r = sh.Ranges[textBoxCell2.Text]) {
          // or using (Range r = sh.Ranges["A6"]) {
          // or using (Range r = sh.Ranges["A6","A8"]) {
          // or using (Range r = sh.Ranges["R6C3","R7C8"]) {
          r.Interior.Color = System.Drawing.Color.FromName(comboBoxColor2.Text); //System.Drawing.Color.Red
          using (Border br = r.Borders[Excel.xlBordersIndex.xlEdgeTop]) {
            br.Color = System.Drawing.Color.FromName(comboBoxColor3.Text); 
            br.Weight = Excel.xlBorderWeight.xlHairline;
            br.LineStyle = Excel.xlLineStyle.xlDouble;
          }
          using (Border br = r.Borders[Excel.xlBordersIndex.xlEdgeLeft]) {
            br.Color = System.Drawing.Color.FromName(comboBoxColor3.Text);
            br.Weight = Excel.xlBorderWeight.xlHairline;
            br.LineStyle = Excel.xlLineStyle.xlDouble;
          }
          using (Border br = r.Borders[Excel.xlBordersIndex.xlEdgeRight]) {
            br.Color = System.Drawing.Color.FromName(comboBoxColor3.Text);
            br.Weight = Excel.xlBorderWeight.xlHairline;
            br.LineStyle = Excel.xlLineStyle.xlDouble;
          }
          using (Border br = r.Borders[Excel.xlBordersIndex.xlEdgeBottom]) {
            br.Color = System.Drawing.Color.FromName(comboBoxColor3.Text);
            br.Weight = Excel.xlBorderWeight.xlHairline;
            br.LineStyle = Excel.xlLineStyle.xlDouble;
          }
        }
      }
    }

    private void buttonKill_Click(object sender, EventArgs e) {
      if (excel != null) {
        excel.Dispose();
        excel = null;
      }
      Excel.KillAllExcelProcesses();
    }



  }
}